require "pkernel_jce/version"

require 'pkernel'

require_relative 'pkernel_jce/keypair'
require_relative 'pkernel_jce/certificate_owner'
require_relative 'pkernel_jce/certificate'
require_relative 'pkernel_jce/identity'
require_relative 'pkernel_jce/crl'
require_relative 'pkernel_jce/csr'
require_relative 'pkernel_jce/ocsp'
require_relative 'pkernel_jce/rfc3161'
require_relative 'pkernel_jce/converter'
require_relative 'pkernel_jce/jfile'
require_relative 'pkernel_jce/jmembuf'
require_relative 'pkernel_jce/io_utils'


module PkernelJce
  #class Error < StandardError; end
  # Your code goes here...

  class Pkernel::KeyPair
    extend PkernelJce::KeyPair

    def self.method_missing(mtd,*args,&block)
      if PkernelJce::KeyPair.respond_to?(mtd)
        PkernelJce::KeyPair.send(mtd,*args,&block)
      else
        super
      end
    end
  end 

  class Pkernel::Certificate
    extend PkernelJce::Certificate

    class KeyUsage
      include PkernelJce::Certificate::KeyUsage
    end

    class ExtKeyUsage
      include PkernelJce::Certificate::ExtKeyUsage
    end
    
    def self.method_missing(mtd,*args,&block)
      if PkernelJce::Certificate.respond_to?(mtd)
        PkernelJce::Certificate.send(mtd,*args,&block)
      else
        super
      end
    end
  end

  class Pkernel::CSR
    extend PkernelJce::CSR

    def self.method_missing(mtd,*args,&block)
      if PkernelJce::CSR.respond_to?(mtd)
        PkernelJce::CSR.send(mtd,*args,&block)
      else
        super
      end
    end
  end
  # end class Pkernel::CSR
  #

  class Pkernel::IdentityFactory
    extend PkernelJce::IdentityFactory
    include PkernelJce::IdentityFactory
 
    def self.method_missing(mtd,*args,&block)
      if PkernelJce::IdentityFactory.respond_to?(mtd)
        PkernelJce::IdentityFactory.send(mtd,*args,&block)
      else
        super
      end
    end
  end
  # end class Pkernel::IdentityFactory
  #


  class Pkernel::CRL
    extend PkernelJce::CRL
  end

  class Pkernel::Rfc3161
    class Response
      extend PkernelJce::Rfc3161::Response
    end

    class Request
      extend PkernelJce::Rfc3161::Request
    end
  end

  class Pkernel::OCSP
    extend PkernelJce::OCSP
  end

  class Pkernel::Converter
    extend PkernelJce::Converter
  end

  #class Pkernel::File
  #  extend PkernelJce::JFile
  #end

  class Pkernel::MemBuf
    extend PkernelJce::JMemBuf
  end

  class Pkernel::IoUtils
    extend PkernelJce::IoUtils
  end
end
