

Dir.glob(File.join(File.dirname(__FILE__),'../../jars/*.jar')).each do |f|
	require_relative f
end

module PkernelJce
  module Provider
    
    BCProvider = org.bouncycastle.jce.provider.BouncyCastleProvider.new
    DefProvider = BCProvider

    def Provider::add_default
      add_provider(DefProvider)
      DefProvider
    end

    def Provider::add_provider(prov)
			if prov != nil
				if prov.is_a?(String) and not prov.empty?
          case prov
          when BCProvider.name
            provInst = BCProvider
						if not java.security.Security.get_providers.to_a.include?(provInst)
              PkernelJce::GConf.instance.glog.debug "Adding security provider '#{provInst.name}'" 
							java.security.Security.add_provider(provInst)
						end
						prov
          else
            PkernelJce::GConf.instance.glog.error "Unknown provider by string '#{prov}'. Please use provider object."
            raise Exception, "Unknown provider by string '#{prov}'. Please use provider object."
          end
				elsif prov.is_a?(java.security.Provider)
					if prov != nil
						if not java.security.Security.get_providers.to_a.include?(prov)
              PkernelJce::GConf.instance.glog.debug "Adding security provider '#{prov.name}'" 
							java.security.Security.add_provider(prov)
						end
						prov
					else
						raise Exception, "Unknown provider object #{prov.inspect}"
					end

				end
			end
      
    end # add_provider

    def Provider::supported_algo(&block)
      prov = DefProvider
      prov.services.each do |ser|
        if block
          block.call(ser)
        else
          STDOUT.puts "Algorithm : #{ser.algorithm}"
        end
      end
    end # supported_algo

  end
end

